﻿using System.Collections.Generic;
using BigBankLib.Domain;

namespace BigBankLib.Data
{
    public class BankAccountMapper
    {

        public const string CURRENT_ACCOUNT_IDENTIFIER = "C";

        public BankAccount ToBankAccount(Dictionary<string, string> bankAccountDetails)
        {
            BankAccount bankAccount = new BankAccount();
            bankAccount.CustomerId = bankAccountDetails["Customer.Id"];
            bankAccount.Number = bankAccountDetails["BankAccount.AccountNumber"];
            bankAccount.Name = bankAccountDetails["BankAccount.AccountName"];
            bankAccount.Type = bankAccountDetails["BankAccount.TypeOfAccount"] == CURRENT_ACCOUNT_IDENTIFIER ? BankAccountType.Current : BankAccountType.Savings;

            // the balance is formatted like $123.45
            string currencySymbol = bankAccountDetails["BankAccount.Balance"].Substring(0, 1);
            decimal amount = decimal.Parse(bankAccountDetails["BankAccount.Balance"].Substring(1));

            bankAccount.Balance = new MonetaryAmount(amount, Currency.FindBySymbol(currencySymbol));

            return bankAccount;
        }

    }
}
