﻿using System.Collections.Generic;

namespace BigBankLib.Domain
{
    public class Currency
    {

        public static readonly Currency GBP = new Currency("GBP", "£");
        public static readonly Currency USD = new Currency("USD", "$");
        public static readonly Currency EUR = new Currency("EUR", "€");

        private static readonly Dictionary<string, Currency> CurrenciesBySymbol;

        static Currency()
        {
            CurrenciesBySymbol = new Dictionary<string, Currency>();
            CurrenciesBySymbol.Add(GBP.Symbol, GBP);
            CurrenciesBySymbol.Add(USD.Symbol, USD);
            CurrenciesBySymbol.Add(EUR.Symbol, EUR);
        }

        public readonly string IsoCurrencyCode;
        public readonly string Symbol;

        private Currency(string isoCurrencyCode, string symbol)
        {
            IsoCurrencyCode = isoCurrencyCode;
            Symbol = symbol;
        }

        public static Currency FindBySymbol(string symbol)
        {
            return CurrenciesBySymbol[symbol];
        }

    }
}
