﻿using System;
using System.Collections.Generic;
using BigBankLib.Data;
using BigBankLib.Domain;
using BigBankService;

namespace BigBankWeb
{
    public partial class _Default : System.Web.UI.Page
    {

        public List<BankAccount> BankAccounts;

        protected void Page_Load(object sender, EventArgs e)
        {
            using (BankingService service = new BankingService())
            {
                List<Dictionary<string, string>> accounts = service.GetBankAccounts(User.Identity.Name);
                BankAccounts = new List<BankAccount>();

                foreach (Dictionary<string, string> account in accounts)
                {
                    BankAccounts.Add(new BankAccountMapper().ToBankAccount(account));
                }
            }
        }
    }
}
